/** @file gtk_aboutbox.cpp

	HITACHI MB-S1 Emulator 'EmuB-S1'
	Skelton for retropc emulator

	@author Sasaji
	@date   2015.01.21 -

	@brief [ about box ]
*/

#include "gtk_aboutbox.h"
#include "../gui_base.h"
#include "../../version.h"

namespace GUI_GTK_X11
{

AboutBox::AboutBox(GtkWidget *parent_window)
{
	char prog_name[128];
	char prog_ver[128];
	char lib_ver[_MAX_PATH];

	sprintf(prog_name,"%s Emulator",DEVICE_NAME);
	sprintf(prog_ver,"\nVersion: %s \"%s\"%s\n",APP_VERSION,PLATFORM
#ifdef _DEBUG
		," (DEBUG)"
#else
		,""
#endif
	);
	GUI_BASE::GetLibVersionString(lib_ver, _MAX_PATH);
	sprintf(&lib_ver[strlen(lib_ver)],"\nGTK+ Version %d.%d.%d",
		gtk_major_version,gtk_minor_version,gtk_micro_version);

	gtk_show_about_dialog(GTK_WINDOW(parent_window),
		"program-name", prog_name,
		"version", prog_ver,
		"copyright", APP_COPYRIGHT,
		"comments", lib_ver,
		NULL);
}

AboutBox::~AboutBox()
{
}

}; /* namespace GUI_GTK_X11 */

