/** @file wav_rec_audio.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2016.11.03 -

	@brief [ record audio using wave format ]
*/

#ifndef _WAV_RECORD_AUDIO_H_
#define _WAV_RECORD_AUDIO_H_

#include "../../common.h"

#if defined(USE_REC_AUDIO) && defined(USE_REC_AUDIO_WAVE)

class EMU;
class REC_AUDIO;
class FILEIO;

class WAV_REC_AUDIO
{
private:
	EMU *emu;
	REC_AUDIO *audio;
	const _TCHAR *rec_path;
	int rec_rate;
	int rec_bytes;
	FILEIO *rec_fp;

	void Release();
	void RemoveFile();

	// record sound
	typedef struct {
		uint32 dwRIFF;
		uint32 dwFileSize;
		uint32 dwWAVE;
		uint32 dwfmt_;
		uint32 dwFormatSize;
		uint16 wFormatTag;
		uint16 wChannels;
		uint32 dwSamplesPerSec;
		uint32 dwAvgBytesPerSec;
		uint16 wBlockAlign;
		uint16 wBitsPerSample;
		uint32 dwdata;
		uint32 dwDataLength;
	} wavheader_t;

public:
	WAV_REC_AUDIO(EMU *new_emu, REC_AUDIO *new_audio);
	~WAV_REC_AUDIO();

	bool IsEnabled();

	/// true:OK false:ERROR
	bool Start(_TCHAR *path, int sample_rate);
	void Stop();
	bool Restart();
//	bool Record(uint8 *buffer, int samples);
//	bool Record(int16 *buffer, int samples);
	bool Record(int32 *buffer, int samples);

	const _TCHAR **GetCodecList();
};

#endif /* USE_REC_AUDIO && USE_REC_AUDIO_WAVE */

#endif /* _WAV_RECORD_AUDIO_H_ */
